#include "spline.hpp"

//-------------------------
// Exercice 5 - Question a
//-------------------------

void Spline::ajoute_point(int x,int y){
  if(n<POINTS_MAX){
    P[n].x=x;
    P[n].y=y;
    ++n;
  }
  else{
    cout<<"Nombre maximal de points atteint"<<endl;
  }
}

//-------------------------
// Exercice 5 - Question c
//-------------------------

void Spline::dessine_points(){
  defini_couleur_dessin(violet);
  if(n>0) P[0].dessine();
  defini_couleur_dessin(cyan);
  for(size_t i=1;i<(statut==EnConstruction?n:n-1);++i){
    P[i].dessine();
  }
}

//-------------------------
// Exercice 5 - Question d
// Exercice 8 - Question b
//-------------------------

void
Spline::dessine(){
  dessine_points();
  if(statut!=EnConstruction){
    dessine_spline();
  }
}

//------------
// Exercice 6
//------------

void
Spline::calcule_Ainverse(){
  //!\ Zone protégée /!\
  // On commence par ajouter artificiellement un point vallant P[0]
  P[n++]=P[0];
  // Fin de zone protégée
  
  //------------
  // Question a 
  //------------
  statut=Statique;

  //------------
  // Question b
  //------------
  
  Matrice A(n,n);
  A[0][0]=1;
  A[0][n-1]=-1;
  A[n-1][0]=2;
  A[n-1][1]=1;
  A[n-1][n-2]=1;
  A[n-1][n-1]=2;
  for(size_t i=1;i<=n-2;i++){
    A[i][i-1]=1;
    A[i][i]=4;
    A[i][i+1]=1;
  }
  Ainverse=A.inverse();
}

//------------
// Exercice 7
//------------

void Spline::calcule(){
  //------------
  // Question a
  //------------
  if(statut==EnConstruction){
    calcule_Ainverse();
  }

  //------------
  // Question b 
  //------------
  Matrice Bx(n,1);
  Matrice By(n,1);
  Bx[0][0]=0;
  Bx[n-1][0]=6*(P[1].x-P[0].x+P[n-2].x-P[n-1].x);
  By[0][0]=0;
  By[n-1][0]=6*(P[1].y-P[0].y+P[n-2].y-P[n-1].y);
  for(size_t i=1;i<=n-2;i++){
    Bx[i][0]=6*(P[i+1].x-2*P[i].x+P[i-1].x);
    By[i][0]=6*(P[i+1].y-2*P[i].y+P[i-1].y);
  }
  Matrice s=Ainverse*Bx;
  Matrice t=Ainverse*By;

  //------------
  // Question c
  //------------
  for(size_t i=0;i<n-1;++i){
    // Coefficient de X^3
    q[i][3]=(s[i+1][0]-s[i][0])/6;
    r[i][3]=(t[i+1][0]-t[i][0])/6;
    
    // Coefficient de X^2
    q[i][2]=s[i][0]/2;
    r[i][2]=t[i][0]/2;

    // Coefficient de X^1
    q[i][1]=P[i+1].x-P[i].x-(s[i+1][0]-s[i][0])/6-s[i][0]/2;
    r[i][1]=P[i+1].y-P[i].y-(t[i+1][0]-t[i][0])/6-t[i][0]/2;

    // Coefficient de X^0
    q[i][0]=P[i].x;
    r[i][0]=P[i].y;
  }
}

//-------------------------
// Exercice 8 - Question a 
//-------------------------

void Spline::dessine_spline(){
  defini_couleur_dessin(blanc);
  double dt=0.01;
  Point P,Q;
  P.x=q[0](0);
  P.y=r[0](0);
  for(size_t k=0;k<n-1;++k){
    for(double t=dt;t<=1;t+=dt){
      Q.x=q[k](t);
      Q.y=r[k](t);
      dessine_ligne(P.x,P.y,Q.x,Q.y);
      P=Q;
    }
  }
}

//------------
// Exercice 9
//------------

void
Spline::reset(){
  n=0;
  statut=EnConstruction;
  point_selectionne=-1;
}

//--------------------------
// Exercice 10 - Question a
//--------------------------

void
Spline::selectionne_point(int x,int y){
  for(size_t i=1;i<n-1;++i){
    if(P[i].est_proche(x,y)){
      point_selectionne=i;
      statut=Dynamique;
      return;
    }
  }
}

//--------------------------
// Exercice 11 - Question c
//--------------------------

void
Spline::deplace_point(int x,int y){
  if(point_selectionne>=0){
    P[point_selectionne].x=x;
    P[point_selectionne].y=y;
    calcule();
  }
}

// //--------------------------
// // Exercice 11 - Question e
//--------------------------

void
Spline::fin_deplacement(){
  point_selectionne=-1;
  statut=Statique;
}

			
//---------------------------
// Fin de la zone a modifier
//---------------------------

Spline::Spline(){
  statut=EnConstruction;
  point_selectionne=-1;
  n=0;
}

StatutSpline
Spline::lire_statut(){
  return statut;
}


